Attribute VB_Name = "sql_1_4_main"
Option Explicit

'This module contains test which illustarate technique
'to work with tables related by ObjectPtr-link

Dim V As New Valentina

Function CreateTestDb() As VDataBase
    
    Dim Db As New VDataBase
    
    'create 'sample' database with default mode & cluster size
    Db.Create App.Path & "\sample"
    
    'then create 2 tables 'Person' & 'Employee'
    
    Dim sql As String
    sql = "CREATE TABLE person ("
    sql = sql + "FirstName String(20) NOT NULL, "
    sql = sql + "MiddleName String(20) NOT NULL, "
    sql = sql + "LastName String(20) NOT NULL )"
    Db.SqlExecute sql
    
    ' ... & 'Employee'
    sql = "CREATE TABLE employee ("
    sql = sql + "PersonPtr ObjectPtr REFERENCES person ON DELETE RESTRICT, "
    sql = sql + "Salary Float NOT NULL )"
    Db.SqlExecute sql
    
    Db.Flush
    Set CreateTestDb = Db
End Function

Sub AddRecords(ByRef Db As VDataBase)
    Dim i As Integer
    Dim sql As String
    Dim res As Long
    
    Const PersonCount As Long = 5
    
    'create some clients
    For i = 1 To PersonCount
        sql = "INSERT INTO person VALUES("
        sql = sql & "'FN#" & i & "', "
        sql = sql & "'MN#" & i & "', "
        sql = sql & "'LN#" & i & "') "
        res = Db.SqlExecute(sql)
    Next
    
    Dim j As Long
    For i = 1 To PersonCount
        
        'each person has two occupations
        sql = "INSERT INTO employee VALUES("
        sql = sql & i & ", "
        sql = sql & CInt(Rnd * 2000) & ")"
        res = Db.SqlExecute(sql)
        
        sql = "INSERT INTO employee VALUES("
        sql = sql & i & ", "
        sql = sql & CInt(Rnd * 2000) & ")"
        res = Db.SqlExecute(sql)
       
    Next
    
End Sub

Sub main()
    
    On Error GoTo Error
    
    'initialize Valentina database engine
    V.Init 10
    
    Dim Db As VDataBase
    Set Db = CreateTestDb
    If Not Db Is Nothing Then
        
        'populate it now with some records
        AddRecords Db
        
        'build cursor
        Dim VC As VCursor
        Dim sql As String
        sql = "SELECT Person.FirstName, Person.MiddleName, Person.LastName, Employee.Salary "
        sql = sql + "FROM Person, Employee "
        sql = sql + "WHERE Employee.Salary > 1000 "
        sql = sql + "Order by Employee.Salary"
        Set VC = Db.SqlSelect(sql)
        
        '... and display result in the 'immediate' window
        If Not VC Is Nothing Then
            DisplayRecords VC
        End If
    End If
    
    'IMPORTANT: destroy the object
    'before calling Shutdown
    Set Db = Nothing
    
    'destroy Valentina database engine and free all resources
    V.ShutDown
    End
    
Error:
    MsgBox Err.Description, vbCritical, "Test failed"
    V.ShutDown
End Sub









