Attribute VB_Name = "sql_1_1_main"
Option Explicit

'This module contains test which illustarate technique
'to work with tables related by RDB-link

Dim V As New Valentina

Function CreateTestDb() As VDataBase
    
    Dim Db As New VDataBase
    
    'create 'sample' database with default mode & cluster size
    Db.Create App.Path & "\sample"
    
    'then create tables 'Client', 'Product' & 'Order'
    
    Dim sql As String
    sql = "CREATE TABLE client ("
    sql = sql + "ID Long NOT NULL, "
    sql = sql + "Name String(20, 'ASCII') NOT NULL, "
    sql = sql + "RegisteredOn Date NOT NULL )"
    Db.SqlExecute sql
    
    ' ...'Product'
    sql = "CREATE TABLE product ("
    sql = sql + "ID Long NOT NULL, "
    sql = sql + "Name String(30, 'ASCII') NOT NULL, "
    sql = sql + "Quantity Long NOT NULL, "
    sql = sql + "Price Float )"
    Db.SqlExecute sql
    
    ' ... & 'Order'
    sql = "CREATE TABLE order ("
    sql = sql + "ClientID Long NOT NULL, "
    sql = sql + "ProductID Long NOT NULL, "
    sql = sql + "Date Date NOT NULL, "
    sql = sql + "Count Byte NOT NULL)"
    Db.SqlExecute sql
    
    Db.Flush
    Set CreateTestDb = Db
End Function

Sub AddRecords(ByRef Db As VDataBase)
    Dim i As Integer
    Dim sql As String
    Dim res As Long
    
    Const ClientCount As Long = 5
    
    'create some clients
    For i = 1 To ClientCount
        sql = "INSERT INTO client VALUES("
        sql = sql & i & ", "
        sql = sql & "'Client#" & i & "', "
        sql = sql & Format(CInt(Rnd * 31), "00") & "." & Format(CInt(Rnd * 12), "00") & "." & 2003 & ")"
        res = Db.SqlExecute(sql)
    Next
    
    Const ProductCount As Long = 10
    
    'create some products
    For i = 1 To ProductCount
        sql = "INSERT INTO product VALUES("
        sql = sql & i & ", "
        sql = sql & "'Product#" & i & "', "
        sql = sql & CInt(Rnd * 1000) & ", "
        sql = sql & CInt(Rnd * 20) & ")"
        res = Db.SqlExecute(sql)
    Next
    
    Const OrderCount As Long = 100
    
    'create some orders
    For i = 1 To OrderCount
        sql = "INSERT INTO order VALUES("
        sql = sql & CInt(Rnd * ClientCount) & ", "                              'ClientID
        sql = sql & CInt(Rnd * ProductCount) & ", "                             'ProductID
        sql = sql & Format(CInt(Rnd * 31), "00") & "." & Format(CInt(Rnd * 12), "00") & "." & 2003 & ", "    'Date
        sql = sql & CInt(Rnd * 3) & ")"                                         'Count
        res = Db.SqlExecute(sql)
    Next
    
End Sub

Sub main()
    
    On Error GoTo Error
    
    'initialize Valentina database engine
    V.Init 10
    
    Dim Db As VDataBase
    Set Db = CreateTestDb
    If Not Db Is Nothing Then
        
        'populate it now with some records
        AddRecords Db
        
        'build cursor
        'select those orders only which belongs to Client#1 and order them by Date
        Dim VC As VCursor
        Dim sql As String
        sql = "SELECT Client.Name, Product.Name, Order.Date, Order.Count "
        sql = sql + "FROM Client, Product, Order "
        sql = sql + "WHERE Client.ID = ClientID And Product.ID = ProductID and Client.Name = 'Client#1' "
        sql = sql + "Order by Order.Date"
        Set VC = Db.SqlSelect(sql)
        
        '... and display result in the 'immediate' window
        If Not VC Is Nothing Then
            DisplayRecords VC
        End If
    End If
    
    'destroy Valentina database engine and free all resources
    V.ShutDown
    End
    
Error:
    MsgBox Err.Description, vbCritical, "Test failed"
    V.ShutDown
End Sub








